/*
	File:		LThermometerPane.h

	Contains:	Thermometer indicator pane for PowerPlant.
				An LProgressIndicator subclass.
				
	Version:	2.0

	Author:		Chris K. Thomas, ckt@best.com
	
	Copyright:	1995 Chris K. Thomas.  All Rights Reserved.
*/

#pragma once

#include <LPane.h>
#include "LProgressIndicator.h"

class LThermometerPane :	public LPane,
							public LProgressIndicator
{
	short					mRight;
	short					mOriginOffset;
	static PixPatHandle		sStripesPat;
	static SInt32			sInstanceCount;
	
public:
	
	static LThermometerPane *	CreateThermometerFromStream(LStream *);

						LThermometerPane(LStream *inStream);
						LThermometerPane(const SPaneInfo &inPaneInfo, ETaskType inTaskType = task_Indeterminate, 
										Int32 inMin = 1, Int32 inMax = 100, Int32 inValue = 1);
	
	virtual				~LThermometerPane();
	
	virtual void		ValueChanged();
	virtual void		DrawSelf();
	
protected:
	void DrawBox();
	void DrawInside();
	
	void DrawInfiniteStripe(Rect &r);
};

